/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * NoGravityMode defines if entities and items should have gravity or not in a Region
 */
@Getter
@AllArgsConstructor
public enum NoGravityMode implements Flag.Value<NoGravityMode> {

    ACTIVE("FLAG_NO_GRAVITY_ACTIVE"),
    INACTIVE("FLAG_NO_GRAVITY_INACTIVE");

    private static NoGravityMode[] values;
    private final String chatValue;

    @Override
    public NoGravityMode[] getValues() {
        if (NoGravityMode.values == null) {
            NoGravityMode.values = NoGravityMode.values();
        }
        return NoGravityMode.values;
    }

    @Override
    public NoGravityMode getValue() {
        return this;
    }

    @Override
    public NoGravityMode getValueOf(final String name) {
        try {
            return NoGravityMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            if (name.equalsIgnoreCase("false")) {
                return NoGravityMode.INACTIVE;
            }
            return NoGravityMode.ACTIVE;
        }
    }
}
